SLASH_BCP1, SLASH_BCP2 = "/bcp", "/bcparser";
local BCRData = {}
local server = GetRealmName()
local player = GetUnitName("player")
local monthNames = {CalendarGetMonthNames()}
local monthNumbers = {["january"]=1,["february"]=2,["march"]=3,["april"]=4,["may"]=5,["june"]=6,["july"]=7,["august"]=8,["september"]=9,["october"]=10,["november"]=11,["december"]=12}
local curDate = date("*t")
local curTime = time()
local month, year = curDate.month, curDate.year
local bcd
local runningTotal
local tempTotal
for i,v in pairs(monthNames) do
	monthNames[i] = strlower(v)
end

local function handler(msg, BCREditBox)
	if (msg ~= nil) then
		local arg1, arg2, arg3 = strsplit(" ", msg)

		if (arg1 == 'sales') then
			if (arg2) then
				arg2 = strlower(arg2)
				if (tContains(monthNames, arg2)) then
					if (arg3) and (#arg3 == 4) and (tonumber(arg3)) then
						arg3 = tonumber(arg3)
						BCPGetMonthlySales(monthNumbers[arg2], arg3)
					else
						BCPGetMonthlySales(monthNumbers[arg2], year)
					end
				else
					BCPGetMonthlySales(month, year)
				end
			else
				BCPGetSales()
			end
		elseif (arg1 == 'purchases') then
			if (arg2) then
				arg2 = strlower(arg2)
				if (tContains(monthNames, arg2)) then
					if (arg3) and (#arg3 == 4) and (tonumber(arg3)) then
						arg3 = tonumber(arg3)
						BCPGetMonthlyPurchases(monthNumbers[arg2], arg3)
					else
						BCPGetMonthlyPurchases(monthNumbers[arg2], year)
					end
				else
					BCPGetMonthlyPurchases(month, year)
				end
			else
				BCPGetPurchases()
			end
		elseif (arg1 == 'total') then
			if (arg2) then
				arg2 = strlower(arg2)
				if (tContains(monthNames, arg2)) then
					if (arg3) and (#arg3 == 4) and (tonumber(arg3)) then
						arg3 = tonumber(arg3)
						BCPGetMonthlyTotal(monthNumbers[arg2], arg3)
					else
						BCPGetMonthlyTotal(monthNumbers[arg2], year)
					end
				else
					BCPGetMonthlyTotal(month, year)
				end
			else
				BCPGetTotal()
			end
		else
			BCRShowHelp()
		end
	else
		BCRShowHelp()
	end
end
SlashCmdList["BCP"] = handler;

function BCPGetMonthlySales(m, y)
	runningTotal = 0
	local _,_,numDays,_ = CalendarGetAbsMonth(m, y)
	local startTime = time{year=y, month=m, day=1, hour=0}
	local endTime = time{year=y, month=m, day=numDays, hour=23, min=59, sec=59}
	if (startTime < curTime) then
		bcd = BeanCounterDB[server][player]["completedAuctions"]
		if (type(bcd) == "table") then
			for i,v in pairs(bcd) do
				for i2,v2 in pairs(bcd[i]) do
					for i3,v3 in pairs(bcd[i][i2]) do
						local _,_,_,_,gold,_,_,atime = strsplit(";", v3)
						if (tonumber(atime) >= startTime) and (tonumber(atime) <= endTime) then
							runningTotal = runningTotal + gold
						end
					end
				end
			end
		end
		print("Total sales for the month of "..date("%B %Y", startTime).." are "..BCPFormatCopperToText(runningTotal, false))
		print("Average sales per day is "..BCPFormatCopperToText(runningTotal/numDays, false))
	else
		print("Future date detected, please try again")
	end
end

function BCPGetSales()
	runningTotal = 0
	local startTime = time()
	local endTime = 1
	bcd = BeanCounterDB[server][player]["completedAuctions"]
	if (type(bcd) == "table") then
		for i,v in pairs(bcd) do
			for i2,v2 in pairs(bcd[i]) do
				for i3,v3 in pairs(bcd[i][i2]) do
					local _,_,_,_,gold,_,_,atime = strsplit(";", v3)
					if (tonumber(atime)) then
						if (tonumber(atime) < tonumber(startTime)) then
							startTime = atime
						elseif (tonumber(atime) > tonumber(endTime)) then
							endTime = atime
						end
					end
					runningTotal = runningTotal + gold
				end
			end
		end
	end
	print("Total sales for the period of "..date("%d %B %Y", startTime).." to "..date("%d %B %Y", endTime).." are "..BCPFormatCopperToText(runningTotal, false))
end

function BCPGetMonthlyPurchases(m, y)
	runningTotal = 0
	local _,_,numDays,_ = CalendarGetAbsMonth(m, y)
	local startTime = time{year=y, month=m, day=1, hour=0}
	local endTime = time{year=y, month=m, day=numDays, hour=23, min=59, sec=59}
	if (startTime < curTime) then
		bcd = BeanCounterDB[server][player]["completedBidsBuyouts"]
		if (type(bcd) == "table") then
			for i,v in pairs(bcd) do
				for i2,v2 in pairs(bcd[i]) do
					for i3,v3 in pairs(bcd[i][i2]) do
						local _,_,_,_,gold,_,_,atime = strsplit(";", v3)
						if (tonumber(atime) >= startTime) and (tonumber(atime) <= endTime) then
							runningTotal = runningTotal + gold
						end
					end
				end
			end
		end
		print("Total purchases for the month of "..date("%B %Y", startTime).." are "..BCPFormatCopperToText(runningTotal, false))
		print("Average purchases per day is "..BCPFormatCopperToText(runningTotal/numDays, false))
	else
		print("Future date detected, please try again")
	end
end

function BCPGetPurchases()
	runningTotal = 0
	local startTime = time()
	local endTime = 1
	bcd = BeanCounterDB[server][player]["completedBidsBuyouts"]
	if (type(bcd) == "table") then
		for i,v in pairs(bcd) do
			for i2,v2 in pairs(bcd[i]) do
				for i3,v3 in pairs(bcd[i][i2]) do
					local _,_,_,_,gold,_,_,atime = strsplit(";", v3)
					if (tonumber(atime)) then
						if (tonumber(atime) < tonumber(startTime)) then
							startTime = atime
						elseif (tonumber(atime) > tonumber(endTime)) then
							endTime = atime
						end
					end
					runningTotal = runningTotal + gold
				end
			end
		end
	end
	print("Total purchases for the period of "..date("%d %B %Y", startTime).." to "..date("%d %B %Y", endTime).." are "..BCPFormatCopperToText(runningTotal, false))
end

function BCPGetMonthlyTotal(m, y)
	runningTotal = 0
	tempTotal = 0
	local _,_,numDays,_ = CalendarGetAbsMonth(m, y)
	local startTime = time{year=y, month=m, day=1, hour=0}
	local endTime = time{year=y, month=m, day=numDays, hour=23, min=59, sec=59}
	if (startTime < curTime) then
		bcd = BeanCounterDB[server][player]["completedAuctions"]
		if (type(bcd) == "table") then
			for i,v in pairs(bcd) do
				for i2,v2 in pairs(bcd[i]) do
					for i3,v3 in pairs(bcd[i][i2]) do
						local _,_,_,_,gold,_,_,atime = strsplit(";", v3)
						if (tonumber(atime) >= startTime) and (tonumber(atime) <= endTime) then
							runningTotal = runningTotal + gold
						end
					end
				end
			end
		end
		bcd = BeanCounterDB[server][player]["completedBidsBuyouts"]
		if (type(bcd) == "table") then
			for i,v in pairs(bcd) do
				for i2,v2 in pairs(bcd[i]) do
					for i3,v3 in pairs(bcd[i][i2]) do
						local _,_,_,_,gold,_,_,atime = strsplit(";", v3)
						if (tonumber(atime) >= startTime) and (tonumber(atime) <= endTime) then
							runningTotal = runningTotal - gold
						end
					end
				end
			end
		end
		if (runningTotal >= 0) then
			print("Total profit/loss for the month of "..date("%B %Y", startTime).." is "..BCPFormatCopperToText(runningTotal, false))
			print("Average profit/loss per day is "..BCPFormatCopperToText(runningTotal/numDays, false))
		else
			tempTotal = tonumber(strsub(runningTotal,2))
			print("Total profit/loss for the month of "..date("%B %Y", startTime).." is -"..BCPFormatCopperToText(tempTotal, false))
			print("Average profit/loss per day is -"..BCPFormatCopperToText(tempTotal/numDays, false))
		end
	else
		print("Future date detected, please try again")
	end
end

function BCPGetTotal()
	runningTotal = 0
	tempTotal = 0
	local startTime = time()
	local endTime = 1
	bcd = BeanCounterDB[server][player]["completedAuctions"]
	if (type(bcd) == "table") then
		for i,v in pairs(bcd) do
			for i2,v2 in pairs(bcd[i]) do
				for i3,v3 in pairs(bcd[i][i2]) do
					local _,_,_,_,gold,_,_,atime = strsplit(";", v3)
					if (tonumber(atime)) then
						if (tonumber(atime) < tonumber(startTime)) then
							startTime = atime
						elseif (tonumber(atime) > tonumber(endTime)) then
							endTime = atime
						end
					end
					runningTotal = runningTotal + gold
				end
			end
		end
	end
	bcd = BeanCounterDB[server][player]["completedBidsBuyouts"]
	if (type(bcd) == "table") then
		for i,v in pairs(bcd) do
			for i2,v2 in pairs(bcd[i]) do
				for i3,v3 in pairs(bcd[i][i2]) do
					local _,_,_,_,gold,_,_,atime = strsplit(";", v3)
					if (tonumber(atime)) then
						if (tonumber(atime) < tonumber(startTime)) then
							startTime = atime
						elseif (tonumber(atime) > tonumber(endTime)) then
							endTime = atime
						end
					end
					runningTotal = runningTotal - gold
				end
			end
		end
	end
	if (runningTotal >= 0) then
		print("Total profit/loss for the period of "..date("%d %B %Y", startTime).." to "..date("%d %B %Y", endTime).." is "..BCPFormatCopperToText(runningTotal, false))
	else
		tempTotal = tonumber(strsub(runningTotal,2))
		print("Total profit/loss for the period of "..date("%d %B %Y", startTime).." to "..date("%d %B %Y", endTime).." is -"..BCPFormatCopperToText(tempTotal, false))
	end
end

function BCPFormatCopperToText(money, truncate)
	if money == nil then
		money = 0
	end
	local GOLD_TEXT = "|cffffd700g|r"
	local SILVER_TEXT = "|cffc7c7cfs|r"
	local COPPER_TEXT = "|cffeda55fc|r"
	local gold = math.floor(money / 10000)
	local silver = math.floor((money - (gold * 10000)) / 100)
	local copper = math.floor(math.fmod(money, 100))
	local text = ""
	
	if( gold > 0 ) then
		text = string.format("%d%s ", gold, GOLD_TEXT)
	end
	
	if( silver > 0 and ( not truncate or gold < 100 ) ) then
		text = string.format("%s%d%s ", text, silver, SILVER_TEXT)
	end
	
	if( text == "" or ( copper > 0 and ( not truncate or gold <= 10 ) ) ) then
		text = string.format("%s%d%s ", text, copper, COPPER_TEXT)
	end
	
	return string.trim(text)
end

function BCRShowHelp()
	print("Valid arguments are:")
	print("SALES [monthName] [fourDigitYear]")
	print("    Prints out how much you made in total, or for a month in a year if given.")
	print("    If no year given or not recognised, defaults to current year")
	print("    If month isn't recognised, defaults to current month")
	print("PURCHASES [monthName] [fourDigitYear]")
	print("    Prints how much you have spent in total, or for a month if given.")
	print("    If no year given or not recognised, defaults to current year")
	print("    If month isn't recognised, defaults to current month")
	print("TOTAL [monthName] [fourDigitYear]")
	print("    Prints out the difference between sales and purchases in total, or for the given month.");
	print("    If no year given or not recognised, defaults to current year")
	print("    If month isn't recognised, defaults to current month")
	print("Please use full month names and 4 digit years if specifying.")
	print("Example:")
	print(" /bcp sales january 2010")
	print(" /bcparser purchases december 2009")
	print(" /bcp total july 2010")
end
